Graphics3D 1024,768,32,1
SetBuffer BackBuffer()
Global timer=CreateTimer(60)
SeedRnd MilliSecs()
WireFrame 0
HidePointer()
;--
Local b.Boden
Type Boden
	Field Mesh
	Field anzahl
	Field clients[29]
End Type
;--
Local o.Objekt
Type Objekt
	Field x
	Field y
	Field Mesh
	Field aktive
End Type
;--
Local h.HindernisArt
Type HindernisArt
	Field Mesh
	Field ID
	Field aktiv
End Type

Local light = CreateLight()


Local Pivot_Steuerung=CreatePivot()
;Camera
Local          Camera=CreateCamera(Pivot_Steuerung)
PositionEntity Camera,0,8,0
RotateEntity   Camera,38,0,0
CameraClsColor Camera,190,185,180
CameraFogColor Camera,180,175,170
CameraFogRange Camera,1,25

;Schnecke
Global         Schnecke = LoadMesh("daten\gamer\schnecke.b3d",Pivot_Steuerung)
PositionEntity Schnecke,0,0,5
RotateEntity   Schnecke,0,180,0
;EntityRadius Schnecke,5,5
EntityType Schnecke,1

;Modell Boden & Hindernisse
;[Block]
Local ini=ReadFile("Boden.ini")
i=0
Global Anzahl

Local AnzahL_Hindernisse=0
While Not Eof(ini)
	readed$=ReadLine(ini)
	If Upper$(readed$)=Upper$("[anzahl]") Then
		Anzahl=Int(ReadLine(ini))-1
		Dim textures(Anzahl,1)
		Dim Boeden(Anzahl,1)
	EndIf
	
	If Upper$(readed$)=Upper$("[include]") Then
		;Boden Hinzufgen
		Folder$=ReadLine(ini)
		Boeden(i,0)=CreateBodenArt(Folder$, i)
		
		;Hindernisse einfgen
		AnzahL_Hindernisse=0
		pfad$="daten\welten\"+Folder$+"\Hindernisse"
		Verz = ReadDir(pfad$)
		If verz<>0
			Repeat
				ordner$ = NextFile$(Verz)
				If ordner$ = "" Then Exit
				If FileType(pfad$+"\"+ordner$)=2 And Left$(ordner$,1)<>"."
					SubVerz = ReadDir(pfad$+"\"+ordner$)
					If SubVerz<>0
						Repeat
							Datei$ = NextFile$(SubVerz)
							If Datei$ = "" Then Exit
							If FileType(pfad$+"\"+ordner$+"\"+datei$)=1 And Right$(datei$,4)=".3ds"
								h.HindernisArt=New HindernisArt
								h\Mesh=LoadMesh(pfad$+"\"+ordner$+"\"+datei$)
								h\ID  =i
								AnzahL_Hindernisse=AnzahL_Hindernisse+1
								HideEntity h\Mesh:PositionEntity h\Mesh,0,500,0
								If Left$(datei$,1)="0" Then h\aktiv=0 Else h\aktiv=1
							EndIf
						Forever
						CloseDir SubVerz
					EndIf
				EndIf
			Forever
			CloseDir Verz
		EndIf
		Boeden(i,1)=AnzahL_Hindernisse
		i=i+1
	EndIf
	If i> Anzahl Then Exit
Wend
CloseFile ini
;[End Block]
;Start Bden erstellen-----
Const standart=15
Boden_Neu(0,Rand(0,Anzahl))
Boden_Neu(0,Rand(0,Anzahl))
Boden_Neu(0,Rand(0,Anzahl))
Boden_Start()

;Allgemeine Variablen
Global speed#=.025
Local ObjektTime
Local Beweglichkeit#
Local links,rechts
Local roll#
Local var
Const wert#=8.90

;Animation
Local ID , AnimWert#

;Lebensbild
Global live=3
Local LiveImage=LoadImage("daten\gamer\live.png")
ScaleImage LiveImage,.5,.5
Local NoLiveImage=LoadImage("daten\gamer\nolive.png")
ScaleImage NoLiveImage,.5,.5

;Struktur des Spieles
Const game=1
Const anim=2
Const menu=3
Const highscore=4
Const aftergame=5
Global status=menu:HideEntity Schnecke

;das Men
Dim but(2)
For i=0 To 2
	but(i)=LoadMesh("daten\menu\"+i+".x",Camera)
	FitMesh but(i),-5,-1.5,0,10,3,1
	MoveEntity but(i),0,i*5-5,10
	EntityOrder but(i),-1
Next
MoveEntity but(2),2.5,0,0
Global MenuMausAlt=0
Global MenuMausNeu=0
Global menuanim
initMenu()

Global Strecke#
Local AnzeigeFnt=LoadFont("verdana",64,1,1,0)
Local Courrier=LoadFont("courier new",64,1,1,0)
Dim HNames$(5)
Dim HWert(5)
loadhighscore()

Repeat
	mx = MouseX()
	my = MouseY()
	
	Beweglichkeit=speed#/5
	
	;Tastenabfrage
	links =KeyDown(30)
	rechts=KeyDown(32)
	
	If MouseDown(1) Then links=1
	If MouseDown(2) Then rechts=1
	
	Select status
		Case game
			;[Block]
			If links  Then TurnEntity Camera,0,0,-.9
			If rechts Then TurnEntity Camera,0,0,+.9
			
			;Kamerabewegung
			roll#=EntityRoll(Camera)
			If roll#<>0 Then
				If     roll#>0
					RotateEntity Camera,38,0,roll#*0.90
					RotateEntity Schnecke,0,180-roll#,0
					
				ElseIf roll#<0
					RotateEntity Camera,38,0,roll#*0.92
					RotateEntity Schnecke,0,180-roll#,0
				EndIf
			EndIf
			
			For i=0 To 6
				If links  Then MoveEntity Pivot_Steuerung,-Beweglichkeit#,0,0
				If rechts Then MoveEntity Pivot_Steuerung, Beweglichkeit#,0,0 
				If EntityX(Pivot_Steuerung) >  wert# Then PositionEntity Pivot_Steuerung, wert#,EntityY(Pivot_Steuerung),EntityZ(Pivot_Steuerung)
				If EntityX(Pivot_Steuerung) < -wert# Then PositionEntity Pivot_Steuerung,-wert#,EntityY(Pivot_Steuerung),EntityZ(Pivot_Steuerung)
				
				
				Boden_Update    (1)
				speed#=speed#*1.001
				If speed#>=0.5 Then speed#=0.5
				Strecke=Strecke+speed
				
				
				UpdateWorld()
				
				;Collision Updaten
				Collisions(2,1,3,2)
				For o.Objekt=Each Objekt
					If o\aktive=1
						t= CountCollisions(o\Mesh)
						If EntityDistance(Schnecke,o\Mesh)<=10
							If t<>0 Then
								o\aktive=0
								speed#=.025
								live=live-1
								ID=Handle(o.Objekt)
								If ID <> 0 Then status=anim : AnimWert#=1 : Exit
							EndIf
						EndIf
					EndIf
				Next
			Next
			;[End Block]
			
		Case anim
			;[Block]
			o.Objekt=Object.Objekt(ID)
			AnimWert#=AnimWert#-.05
			EntityAlpha(o\Mesh,AnimWert#)
			
			If AnimWert<=0 Then 
				status=game : ClearCollisions()
				If live=0 Then status=aftergame : AmbientLight 100,100,100 : FlushKeys()
			EndIf
			
			
			;[End Block]
			
		Case menu
			;[Block]
			If menuanim=0
				For i=0 To 6
					Boden_Update    (0)
					speed#=speed#*1.001
					If speed#>=0.05 Then speed#=0.05
				Next
				MenuMausNeu=my/(768/3)
				If MenuMausNeu<>MenuMausAlt Then MoveEntity but(2-MenuMausNeu),2.5,0,0 : MoveEntity but(2-MenuMausAlt),-2.5,0,0
				MenuMausAlt=MenuMausNeu
				If MouseHit(1) Then menuanim=1 : MenuAnimID=2-MenuMausNeu :  MenuAnimAngel=0
				
			Else
				MenuAnimAngel=MenuAnimAngel+3
				RotateEntity but(MenuAnimID),0,MenuAnimAngel,0
				AmbientLight 100+(100*(MenuAnimAngel/180.0)),100+(155*(MenuAnimAngel/180.0)),100+(100*(MenuAnimAngel/180.0))
				If MenuAnimAngel>=180 Then
					Select MenuAnimID
						Case 2
							status=game : ShowEntity Schnecke : For i=0 To 2 : HideEntity(but(i)) : Next
							
						Case 1
							status=highscore : For i=0 To 2 : HideEntity(but(i)) : Next :FlushKeys()
						Case 0
							End
					End Select
				EndIf
			EndIf
			;[End Block]
			
		Case highscore
			;[Block]
			For i=0 To 6
				Boden_Update    (0)
				speed#=speed#*1.001
				If speed#>=0.05 Then speed#=0.05
			Next
			;[End Block]
	End Select
	
	RenderWorld()
	
	Select status
		Case game
			For i=1 To 3
				If live=>i Then
					DrawImage LiveImage,GraphicsWidth()-i*75,10
				Else
					DrawImage NoLiveImage,GraphicsWidth()-i*75,10
				EndIf
			Next
			SetFont AnzeigeFnt
			Text 10,20,Int(Strecke)+" M"
			
		Case anim
			For i=1 To 3
				If live=>i Then
					DrawImage LiveImage,GraphicsWidth()-i*75,10
				Else
					DrawImage NoLiveImage,GraphicsWidth()-i*75,10
				EndIf
			Next
			SetFont AnzeigeFnt
			Text 10,20,Int(Strecke)+" M"
			
		Case menu
			DrawImage LiveImage,mx,my
			
		Case aftergame
			Text 512,100,"Sie haben "+Int(Strecke)+" Meter",1
			Text 512,150,"zurckgelegt !",1
			Text 512,300,"Fr den Highscore bentigt man",1
			Text 512,350,HWert(4)+" Meter",1
			If HWert(4)<=Strecke Then
				Text 512,500,"Du bist im Highscore !",1
				If GetKey() Then 
					Locate 0,0
					name$=Input("Dein Name: ")
					HNames$(5)=name$
					HWert(5)=Int(Strecke)
					DebugLog HWert(5)
					For i=4 To 0 Step -1
						If HWert(i)<=HWert(i+1) Then
							tmp1$=HNames$(i+1)
							tmp  =HWert(i+1)
							HNames(i+1)=HNames(i)
							HWert(i+1) =HWert(i)
							HNames(i)=tmp1$
							HWert(i) =tmp
						Else
							Exit
						EndIf
					Next
					SaveScore()
					initMenu()
					
					
				EndIf
			Else
				Text 512,500,"Leider hat es nicht gereicht",1 
				If GetKey() Then 
					initMenu()
				EndIf
			EndIf
			Text 512,650,"Beliebige Taste drcken",1
			
		Case highscore
			SetFont Courrier
			Text 512,50,"Highscore",1
			For i=0 To 4
				Text 100,i*75+150,LSet$(HNames(i),17)+HWert(i)
			Next
			Text 512,600,"Zum Men Taste drcken",1
			If GetKey() Then initMenu()
	End Select
	
	
	;FPS
	;ms=MilliSecs():Text 0,20,fps 
	;If ms>mt Then mt=ms+502:fps=frame:frame=0 Else frame=frame+2
	
	WaitTimer(timer)
	Flip(1)
	
	If KeyHit(1) Then initMenu()
Forever

Function initMenu()
	AmbientLight 100,100,100
	free_all_objekts()
	Strecke=0
	status=menu
	MenuMausAlt=0
	MenuMausNeu=0
	menuanim=0
	FlushMouse()
	For i=0 To 2
		ShowEntity but(i)
		PositionEntity but(i),0,i*5-5,10
		RotateEntity but(i),0,0,0
	Next
	MoveEntity but(2),2.5,0,0
	live=3
End Function
Function SaveScore()
	high=WriteFile("daten\highscore")
	For i=0 To 4
		WriteString(high,HNames$(i))
		WriteInt(high,HWert(i))
	Next
	CloseFile high
End Function
Function loadhighscore()
	high=ReadFile("daten\highscore")
	For i=0 To 4
		HNames$(i)=ReadString(high)
		HWert(i)=ReadInt(high)
	Next
	CloseFile high
End Function

Function Boden_Start()
	Local B.Boden=First Boden
	PositionEntity B\Mesh,0,0,0
End Function
Function Boden_Update(modus)
	b.Boden=First Boden
	MoveEntity(B\Mesh,0,0,-speed#)
	z#=EntityZ(B\Mesh)
	For i=0 To B\anzahl
		Objekt_Pos(B\clients[i],z#)
	Next
	
	If z#=<0 Then
		B.Boden=After B.Boden
		PositionEntity B\Mesh,0,0,z#+560
		For i=0 To B\anzahl
			Objekt_Pos(B\clients[i],z#+560)
		Next
	EndIf
	
	If z#<(-560) Then
		If modus=1
			Boden_Neu(standart,Rand(0,Anzahl))
		Else
			Boden_Neu(0,Rand(0,Anzahl))
		EndIf
		Boden_Free()
	EndIf
End Function
Function Boden_Neu(Anzahl,Art)
	b.Boden=New Boden
	b\Mesh=CopyEntity(Boeden(Art,0))
	b\anzahl=Anzahl-1
	
	For i#=0 To b\anzahl
		b\clients[i]=Objekt_Neu(Rand(-8,8) , Float#((560.0*(b\anzahl-1))/b\anzahl)*(Float#(i/b\anzahl)) , Art )
	Next
End Function
Function Boden_Free()
	Local i
	Local b.Boden=First Boden
	For i=0 To b\anzahl
		Objekt_Free(b\clients[i])
	Next
	FreeEntity b\Mesh
	Delete b.Boden
End Function
Function free_all_objekts()
	For b.Boden=Each Boden
		For i=0 To b\anzahl
			Objekt_Free(b\clients[i])
		Next
		b\anzahl=-1
	Next
	
End Function
Function CreateBodenArt(Folder$ ,index)
	Local surface,brush
	Local texOriginal
	
	textures(index, 0)=LoadTexture("daten\welten\"+Folder$+"\Boden.jpg")
	textures(index, 1)=LoadTexture("daten\welten\"+Folder$+"\Wand.jpg")
	
	Local info=ReadFile("daten\welten\"+Folder$+"\Info.ini")
	Local BodenXScale=ReadLine(info)
	Local BodenYscale=ReadLine(info)
	Local SideXScale=ReadLine(info)
	Local SideYScale=ReadLine(info)
	CloseFile(info)
	
	Local Entity=LoadMesh("daten\welten\"+Folder$+"\modell.3ds")
	
	ScaleEntity Entity,2,1,8
	PositionEntity Entity,0,0,500
	HideEntity     Entity
	
	;Boden
	surface=GetSurface(Entity,1)
	brush  = CreateBrush()
	texOriginal=GetBrushTexture(brush)
	ScaleTexture textures(index, 0),BodenXScale,BodenYscale
	BrushTexture brush,textures(index, 0),0,0
	PaintSurface surface,brush
	FreeBrush brush
	
	;Seite
	surface=GetSurface(Entity,3)
	brush  = CreateBrush()
	texOriginal=GetBrushTexture(brush)
	ScaleTexture textures(index, 1),SideXScale,SideYScale
	BrushTexture brush,textures(index, 1),0,0
	PaintSurface surface,brush
	FreeBrush brush
	
	Return Entity
End Function
Function Objekt_Collisions()
	Local o.Objekt , Abst#
	For o.Objekt=Each Objekt
		If o\aktive=1 Then 
			Abst#=EntityDistance(Schnecke,o\Mesh)
			If Abst#<=1.5 Then 
				o\aktive=0
				speed#=.025
				live=live-1
				Return Handle(o.Objekt)
			EndIf
		EndIf
	Next
End Function
Function Objekt_Free(ObjHandle)
	Local o.Objekt=Object.Objekt(ObjHandle)
	FreeEntity o\Mesh
	Delete o.Objekt
End Function
Function Objekt_Pos(ObjHandle,z#)
	Local o.Objekt=Object.Objekt(ObjHandle)
	PositionEntity o\Mesh,o\x,0,z#+o\y
End Function
Function Objekt_Neu(x,y,Art)
	Local O.Objekt=New Objekt
	Stelle = Rand(1,Boeden(Art,1))
	Local h.HindernisArt
	For h.HindernisArt=Each HindernisArt
		If h\ID = Art Then
			i=i+1
			If i=stelle Then
				O.Objekt=New Objekt
				O\Mesh=CopyMesh(h\Mesh)
				Exit
			EndIf
		EndIf
	Next
	If h\aktiv=1 Then 
		PositionEntity O\Mesh,0,500,0
		EntityBox  O\Mesh,EntityX(O\Mesh),EntityY(O\Mesh),EntityZ(O\Mesh),MeshWidth(O\Mesh),MeshHeight(O\Mesh),MeshDepth(O\Mesh) : EntityType O\Mesh,2
	EndIf
	
	O\x=x:O\y=y:O\aktive=1
	Return Handle(O.Objekt)
End Function

;~IDEal Editor Parameters:
;~F#8#F#17#31#AE#E2#F0#10F#16F#180#188#191#195#1AE#1B7#1C0#1C9#1F1#1FF#204
;~F#208
;~C#Blitz 3D