a$ = CommandLine$()
If a$ = "W" Then Graphics 1024,768,0,2 : Else Graphics 1024,768,16,1
AppTitle "Super Dog"

;--Types--;
Type enemy
	Field x,y,dir,ys
End Type
Global e.enemy

Type tele
	Field x,y,typ,c ;typ: 0 = beamer, 1 = rauskommer; color: 0=blau, 1 = rot, 2=gruen 3=gelb
End Type
Global t.tele

;--Consts--;
Const ANZAHL_MAPS = 9	;BEGINN BEI EINS (1)
Const ANZAHL_STORIES = 9;BEGINN BEI NULL (0)
Const gsMenu     = 0
Const gsGame     = 1
Const gsStory    = 2
Const gsGAMEOVER = 3

;--Ressourcen--;
Global tilesetImage = LoadAnimImage("gfx\tileset.png",30,30,0,4)
Global enemyImage = LoadAnimImage("gfx\enemy.png",30,30,0,2)
Global dogImage = LoadAnimImage("gfx\dog.png",30,30,0,2)
Global boneImage = LoadImage("gfx\bone.png")
Global herzImg = LoadImage("gfx\herz.png")
Global GAMEOVERIMAGE = LoadImage("gfx\GAMEOVER.png") : MidHandle GAMEOVERIMAGE
Global herzimage = LoadImage("gfx\herzm.png")
Global bonemini = LoadImage("gfx\bonemini.png")
Global teleimg = LoadAnimImage("gfx\teleports.png",30,30,0,8)
Global keys = LoadAnimImage("gfx\keys.png",30,30,0,6)
Global keysm = LoadAnimImage("gfx\keysm.png",16,16,0,3)
Global title = LoadImage("gfx\title.png") :MidHandle title

;--Variablen & Arrays--;
Dim maps(29,25,1,ANZAHL_MAPS)
Dim stories$(19,ANZAHL_STORIES)

Global menuselect

Global ende = 0
Global gamestate = gsMenu
Global gamestate2

Global leben, inv, invt#
Global countKnochen
Global haveKnochen
Global gotkeys[2]

Global px, py, pys, pdir, pdraw

Global timer = CreateTimer(60)

;--Init--;
SetBuffer BackBuffer()
ClsColor 0,0,128
loadmaps()

;--Mainloop--;
While ende = 0

	Select gamestate
		Case gsMenu :   menu()
		Case gsGame :   game(gamestate2)
		Case gsStory:   story(gamestate2)
		Case gsGAMEOVER:gameover()
	End Select
	
	If KeyHit(8) Then SaveBuffer(FrontBuffer(),"screenie.png")
	
	WaitTimer timer
	Flip 0
	Cls

Wend

End

;--menu--;
Function menu()
	If KeyHit(208) Or KeyHit(200) Then menuselect = 1-menuselect
	DrawImage title,512,140
	Text 512,300,"LOS!",1,1
	Text 512,350,"Weg hier!",1,1
	Text 512,300+menuselect*50,"->                <-",1,1
	Text 0,754,"by Tennisball"
	If KeyHit(28) Then
		If menuselect = 0 Then gamestate = gsStory : gamestate2 = 1 : leben = 5
		If menuselect = 1 Then ende = 1
	End If
	If KeyHit(1) Then ende = 1
End Function


;--loadmappack--;
Function loadmaps()
Local filename$ = "data\maps"
Local stream = ReadFile(filename)
Local countMaps = ReadInt(stream)
For i = 0 To countMaps
	For x = 0 To 29
		For y = 0 To 24
			For z = 0 To 1
				maps(x,y,z,i) = ReadInt(stream)
			Next
		Next
	Next
Next
filename = "data\story"
stream = ReadFile(filename)
Local countStories = ANZAHL_STORIES
Local inp$
Local a
For i = 0 To countStories
	Repeat
		inp$ = ReadLine(stream)
		If inp$ <> "--" Then stories(a,i) = inp$
		a = a + 1
	Until inp$ = "--"
	a=0
Next
End Function


;--story--;
Function story(gs)
Local storynr = gs-1
For i = 0 To 19
Text 512,100+i*30,stories(i,storynr),1,1
Next
If KeyHit(28) Then 
	If gamestate2-1<ANZAHL_MAPS initlvl(gamestate2-1):gamestate=gsGame:FlushKeys():inv=0:invt=0
	If gamestate2-1=ANZAHL_MAPS gamestate=gsMenu
End If
If KeyHit(1) Then gamestate=gsMenu : FlushKeys()
End Function

;--game--;
Function game(gs)
Local lvlnr = gs-1
drawtiles(lvlnr)
drawTheRest()
fall(lvlnr)
If leben = 0 Then gamestate = gsGAMEOVER
If pys=0 Then controls(lvlnr)
If pys=0 And KeyHit(208) Then buddeln(lvlnr)
If KeyHit(19) Then kill(lvlnr)
If KeyHit(1) Then Origin 0,0 : gamestate=gsMenu : FlushKeys()
moveenem(lvlnr)
collision(lvlnr)
If haveKnochen=countKnochen Then 
	gamestate2=gamestate2+1
	gamestate=gsStory:FlushKeys():Origin 0,0
	If gamestate2-2>=ANZAHL_STORIES Then gamestate=gsMenu:inv=0:invt=0
End If
If gamestate2 < 6 And KeyHit(31) initlvl(5):gamestate=gsGame:FlushKeys():inv=0:invt=0:gamestate2=6
End Function

;--initlvl--;
Function initlvl(lvl)
For i=0To 2:gotkeys[i]=0:Next
Delete Each enemy
Delete Each tele
countKnochen = 0
haveKnochen = 0
For x = 0 To 29
	For y = 0 To 24
		z = maps(x,y,1,lvl)
		If z=2 Then createenemy(x,y)
		If z=3 Then px=x*30: py=y*30
		If z>4 And z<13 Then createtele(x,y,z-5)
		If z=23 Then maps(x,y,1,lvl) = 1 : z = 1
		If z=24 Then maps(x,y,1,lvl) = 4
		If z>24 Then maps(x,y,1,lvl) = z-12
		If z=1 Then countKnochen = countKnochen + 1
		z = maps(x,y,0,lvl)
		If z=21 Then maps(x,y,0,lvl) = 1
		If z=20 Then maps(x,y,0,lvl) = 3
	Next
	maps(x,25,0,lvl)=2
Next
pdraw=1
Origin 62,9
End Function

;--createenemy--;
Function createenemy(x,y)
e = New enemy
e\x = x*30
e\y = y*30
End Function

;--drawtiles--;
Function drawtiles(lvl)
	Rect -1,-1,902,752,0
	For x = 0 To 29
		For y = 0 To 24
			z = maps(x,y,0,lvl)
			If z<4DrawImage tilesetImage,X*30,Y*30,z
			z=maps(x,y,1,lvl)
			If z=1 Then DrawImage boneImage,x*30,y*30
			If z=4 Then DrawImage herzImg,x*30,y*30
			If z>12And z<19 Then DrawImage keys,x*30,y*30,z-13
			;Text x*30,y*30,maps(x,y,1,lvl)
		Next
	Next
End Function

;--DrawTheRest--
Function DrawTheRest()
	For e = Each enemy
		DrawImage enemyImage,e\x,e\y,e\dir
	Next
	For t = Each tele
		DrawImage teleImg,t\x,t\y,t\typ*4+t\c
	Next
	If pdraw = 1 Then DrawImage dogImage,px,py,pdir
	DrawImage herzImage,795,3
	Text 810,3," x "+leben+" / 5"
	DrawImage bonemini,795,25
	Text 810,25," x "+haveKnochen + " / " + countKnochen
	For i=0To 2
		If gotkeys[i]=1Then DrawImage keysm,810+20*i,47,i
	Next
End Function

;--controls--;
Function controls(lvl)
If KeyDown(203) Then
	z = maps((px-3)/30,py/30,0,lvl)
	pdir = 1
	If px>0 And z=0Or z=20Or z=21 Then px=px-3
	If px>2 Then
	z = maps((px-3)/30,py/30,1,lvl)
	If z>15And z<19 Then k=tuer(z):If k=1 Then
	maps((px-3)/30,py/30,1,lvl)=28+z-16:Else px=px+3:EndIf
	End If
End If
If KeyDown(205) Then
	If px<870Then
	z = maps(px/30+1,py/30,0,lvl)
	pdir = 0
	If z=0Or z=20Or z=21 Then px=px+3
	End If
	If px<871 Then
	z = maps((px+29)/30,py/30,1,lvl)
	If z>15And z<19 Then k=tuer(z):If k=1 Then maps(px/30,py/30,1,lvl)=28+z-16:Else px=px-3
	End If
End If


End Function

;--fall--;
Function fall(lvl)
k=maps(px/30,py/30+1,0,lvl)
If px<871 l=maps((px+29)/30,py/30+1,0,lvl)
m=maps(px/30,py/30+1,1,lvl)
If px<871 n=maps((px+29)/30,py/30+1,1,lvl)
o=0
If m>15And m<19 Then 
	If tuer(m)=1 Then
		o=1
		maps(px/30,py/30+1,1,lvl)=28+m-16
	End If
Else 
	o=1
End If
If n>15And n<19 Then
	If tuer(n)=1 Then 
		o=1
		maps((px+29)/30,py/30+1,1,lvl)=28+n-16
	Else 
		o=0
	End If
End If

If k=0Or k=20Or k=21 Then
	If l=0Or l=20Or l=21 Then
		If o=1
			pys = 5 
		Else 
			pys=0
		End If
	Else
		pys=0
	End If
Else 
	pys=0
End If
py = py +pys
If inv Then invt = invt + 1
If inv = 1 And invt Mod 3 = 0 Then pdraw=1-pdraw
If invt = 240 Then inv = 0 : invt = 0
End Function

;--moveenem--;
Function moveenem(lvl)
For e = Each enemy
	If e\ys =0 Then
	If e\dir = 1 Then
		If e\x>0 Then
			z=maps((e\x-3)/30,e\y/30,0,lvl)
			If z=0Or z=20Or z=21 Then 
				e\x = e\x - 1
			Else 
				e\dir = 0
			End If
		Else
			e\dir = 0
		End If
	End If
			

	If e\dir = 0 Then
		If e\x<870 Then
			If e\x < 871 Then 
			z = maps((e\x+29)/30,e\y/30,0,lvl)
			If z=0Or z=20Or z=21 Then 
				e\x = e\x + 1
			Else 
				e\dir = 1
			End If
			End If
		Else
			e\dir = 1
		End If
	End If
	End If
	
	k=maps(e\x/30,e\y/30+1,0,lvl)
	If e\x < 871 Then l=maps((e\x+29)/30,e\y/30+1,0,lvl)
	If e\dir=0 Then If k=0Or k=20Or k=21 Then e\ys = 5 : Else e\ys=0
	If e\dir=1 Then If l=0Or l=20Or l=21 Then e\ys = 5 : Else e\ys=0
	e\y = e\y +e\ys
	
	If ImagesOverlap(dogimage,px,py,enemyImage,e\x,e\y) And inv = 0 Then leben = leben - 1 : inv = 1
Next
End Function

;--collision--;
Function collision(lvl)
If px<871Then q=maps((px+29)/30,py/30,1,lvl)
If px>2 Then w=maps(px/30,py/30,1,lvl)
If pdir=0And q=1 haveKnochen=haveKnochen+1:maps((px+29)/30,py/30,1,lvl) = 23
If pdir=1And w=1 haveKnochen=haveKnochen+1:maps(px/30,py/30,1,lvl) = 23
If pdir=0And q=4 leben=leben+1:maps((px+29)/30,py/30,1,lvl)=24
If pdir=1And w=4 leben=leben+1:maps(px/30,py/30,1,lvl) =24
If pdir=0And q>12And q<16 Then gotKeys[q-13]=1:maps((px+29)/30,py/30,1,lvl)=25+q-13
If pdir=1And w>12And w<16 Then gotKeys[w-13]=1:maps(px/30,py/30,1,lvl)=25+w-13
If leben >5 Then leben = 5
Local telecolor, telecollide
For t = Each tele
	If t\typ = 0 Then
		If px<871 Then z = maps(px/30,py/30,1,lvl)
		If dir=0 If z=5 Or z=6Or z=7Or z=8 Then
			telecollide = 1
			telecolor = z-5
			Exit
		End If
		If px>2 Then z = maps((px-3)/30,py/30,1,lvl)
		If dir=1 If z=5 Or z=6Or z=7Or z=8 Then
			telecollide = 1
			telecolor = z-5
			Exit
		End If
	End If
Next
If telecollide = 1 Then
	For t = Each tele
		If t\typ = 1 And t\c = telecolor Then px = t\x : py = t\y
	Next
End If
End Function

;--buddeln--;
Function buddeln(lvl)
Local a=maps((px)/30,py/30+1,0,lvl)
Local b=maps((px)/30,py/30+1,0,lvl)
If pdir = 0 And a=1 Or a=3 Then maps((px)/30,py/30+1,0,lvl)=20+a Mod 3
If pdir = 1 And b=1 Or b=3 Then maps((px)/30,py/30+1,0,lvl)=20+b Mod 3
End Function

;--gameover--;
Function gameover()
DrawImage GAMEOVERIMAGE,450,768/2
Flip 0
FlushKeys():WaitKey():FlushKeys()
gamestate = gsMenu
Origin 0,0
End Function

;--createtele--;
Function createtele(x,y,typ)
t = New tele
t\x = x*30
t\y = y*30
t\typ = typ / 4
t\c = typ Mod 4
End Function

;--kill--;
Function kill(lvl)
leben = leben - 1
initlvl(lvl)
End Function

;--tuer--;
Function tuer(x)
If gotkeys[x-16] Then Return 1 : Else Return 0
End Function